<?php
namespace nur\sery\wip\schema\_assoc;

use nur\sery\wip\schema\_scalar\ScalarWrapper;
use nur\sery\wip\schema\input\Input;
use nur\sery\wip\schema\Schema;
use nur\sery\wip\schema\Wrapper;
use nur\sery\wip\schema\WrapperContext;

class AssocWrapperContext extends WrapperContext {
  const DEFAULT_ENSURE_ARRAY = false;
  const DEFAULT_ENSURE_ASSOC = true;
  const DEFAULT_ENSURE_KEYS = true;
  const DEFAULT_ENSURE_ORDER = true;

  public bool $ensureArray;
  public bool $ensureAssoc;
  public bool $ensureKeys;
  public bool $ensureOrder;

  public function resetParams(?array $params): void {
    parent::resetParams($params);
    $this->ensureArray = $params["ensure_array"] ?? self::DEFAULT_ENSURE_ARRAY;
    $this->ensureAssoc = $params["ensure_assoc"] ?? self::DEFAULT_ENSURE_ASSOC;
    $this->ensureKeys = $params["ensure_keys"] ?? self::DEFAULT_ENSURE_KEYS;
    $this->ensureOrder = $params["ensure_order"] ?? self::DEFAULT_ENSURE_ORDER;
  }

  public ?ScalarWrapper $arrayWrapper = null;

  /** liste des clés valides */
  public array $keys;

  /** @var Wrapper[] */
  public array $keyWrappers;
}
